// This example serves as a review of content from CS 1 or CptS 121. The program
// reads all lines or records from a .csv file and separates the fields from each
// record. The program places copies of the fields into an array of structs. The program
// supports adding, removing, and reorganzing the movies in the list.

// History: 1/12/24 - opened "movies.csv" for mode read. read all records from the file
//                    into a 2-D array of characters, where each row represents one line
//                    or record from the file. separated the fields (title, year) from each line
//                    and placed copies into an array of structs called "records".       

#include "movieCollection.h"

int main(void)
{
	FILE* inputStream = fopen("movies.csv", "r");
	char lines[MAX_ROWS][MAX_COLS] = { {'\0'}};
	MovieRecord records[MAX_ROWS] = { {"", 0}};
	int lineNum = 0, row_index = 0;

	if (inputStream != NULL)
	{
		// we opened file successfully for mode read

		// let's read all the lines in the file and place each line into a single
		// row of our 2-D array called "lines"
		while (fgets(lines[lineNum], MAX_COLS, inputStream) != NULL) // fgets() return NULL if no more lines in
																	 // the input stream - alternative: !feof (inputStream)
		{
			// let's see if we read in each line correctly - echo to the screen
			printf("row %d: %s\n", lineNum, lines[lineNum]);
			++lineNum;
		}

		// we have all lines read from the file stored in our 2-D array called "lines"

		while (row_index < lineNum) // walk through each row of "lines" and
			                        // separate title and year, and copy into
			                        // correspoinding element of the "records" array of structs
		{
			// recall the declaration for strtok ():
			// char * strtok (char * str, const char * delimiter);
			// strtok returns a pointer (an address) to the first character of the newly formed
			//     substring, also known as a token. this means the function doesn't return
			//     a copy of the token (entire string), just an address to the first character.
			//     if we want a copy of the string placed in the tile field of a struct, then
			//     we must use strcpy () as illustrated below.
			strcpy(records[row_index].title, strtok(lines[row_index], ","));
			records[row_index].year = atoi(strtok(NULL, "\n")); // on successive calls
			    // to strtok () we want to continue separating the original line from the
			    // the last formed token, so we use the NULL pointer as the first argument
			    // instead of the original lines[row_index] address - we need to convert
			    // the year from a form like "2002" to 2002 (integer) - atoi () performs this
			    // operation. note: "\n" was used as the delimiter in the second call to
			    // strtok () in order to remove the newline at the end of each line read
			    // using fgets ().
			printf("records[%d].title: %s, .year: %d\n", row_index, records[row_index].title,
				records[row_index].year);

			++row_index; // go to the next line in the 2-D array
		}
	}

	return 0;
}